#include <stdlib.h>
#include <conio.h>
#include <string.h>

const char FMT_VALUE[] = "%-6s %1c %1c %3d %p";
const char GLOBAL[] = "global";
const char LOCAL[] = "local";
const char CHECKED = '*';
const char UNCHECKED = ' ';

const int global_const_v = 100;
int global_v = 110;

void print_array(const char array[], int count) {
    int i;

    for (i = 0; i < count; ++i) {
        unsigned char a = array[i];

        cprintf("%02x ", a);
    }
}

int main(void)
{
    unsigned int frame = 0;
    int y = 1;

    // ʂ̏
    clrscr();

    // zueXg
    {
        const static int local_const_static_v = 200;
        const int local_const_v = 210;
        static int local_static_v = 220;
        int local_v = 230;

        gotoxy(1, y++); cprintf("Memory C S V   Addr");
        gotoxy(1, y++); cprintf("------ - - --- ------");
        gotoxy(1, y++); cprintf(FMT_VALUE, GLOBAL, CHECKED, CHECKED,
                                global_const_v, &global_const_v);
        gotoxy(1, y++); cprintf(FMT_VALUE, GLOBAL, UNCHECKED, CHECKED,
                                global_v, &global_v);
        gotoxy(1, y++); cprintf(FMT_VALUE, LOCAL, CHECKED, CHECKED,
                                local_const_static_v, &local_const_static_v);
        gotoxy(1, y++); cprintf(FMT_VALUE, LOCAL, CHECKED, UNCHECKED,
                                local_const_v, &local_const_v);
        gotoxy(1, y++); cprintf(FMT_VALUE, LOCAL, UNCHECKED, CHECKED,
                                local_static_v, &local_static_v);
        gotoxy(1, y++); cprintf(FMT_VALUE, LOCAL, UNCHECKED, UNCHECKED,
                                local_v, &local_v);
    }

    y++;

    // ANZX֐eXg
    {
        // memchr
        char a[] = {'A','B','c','d'};
        char *p;

        gotoxy(1, y++); cprintf("a[]=%4.4s", a);
        p = memchr(a, 'A', sizeof(a));
        gotoxy(2, y++); cprintf("memchr(%p,'A',%d)=>%p", a, sizeof(a), p);
        p = memchr(a, 'c', sizeof(a));
        gotoxy(2, y++); cprintf("memchr(%p,'c',%d)=>%p", a, sizeof(a), p);
    }

    y++;

    {
        // memcmp
        char a1[] = {'A','b','\0','c'};
        char a2[] = {'b','\0','c'};
        int result;

        gotoxy(1, y++); cprintf("a1[]="); print_array(a1, sizeof(a1)/sizeof(a1[0]));
        gotoxy(1, y++); cprintf("a2[]="); print_array(a2, sizeof(a2)/sizeof(a2[0]));
        result = memcmp(a1, a2, sizeof(a2));
        gotoxy(2, y++); cprintf("memcmp(a1,a2)=>%d", result);
        result = memcmp(&a1[1], a2, sizeof(a2));
        gotoxy(2, y++); cprintf("memcmp(&a1[1],a2)=>%d", result);
    }

    y++;

    {
        // memmove
        char a[] = {1, 2, 3, 4};

        gotoxy(1, y++); cprintf("a[]="); print_array(a, sizeof(a)/sizeof(a[0]));
        memmove(&a[1], &a[2], 2);
        gotoxy(2, y++); cprintf("memmove(&a[1],&a[2],2)");
        gotoxy(1, y++); cprintf("a[]="); print_array(a, sizeof(a)/sizeof(a[0]));
    }

    y++;

    {
        // memset
        char a[4] = {0};

        gotoxy(1, y++); cprintf("a[]="); print_array(a, sizeof(a)/sizeof(a[0]));
        memset(a, 255, sizeof(a));
        gotoxy(2, y++); cprintf("memset(a,255,sizeof(a))");
        gotoxy(1, y++); cprintf("a[]="); print_array(a, sizeof(a)/sizeof(a[0]));
    }

    y++;

    // ̈搧֐eXg
    {
        // malloc, free
        char *p = malloc(sizeof(char)*4);

        gotoxy(1, y++); cprintf("malloc(sizeof(char)*4)=>%p", p);
        free(p);
    }

    // I点Ȃ߂̖[v
    while(1) {
        gotoxy(0, 0);
        cprintf("%8d", frame++);
    }

    return 0;
}
